=== debian/changelog ===
iitii (0.0+git20191030.85209e0-4) unstable; urgency=medium

  * Fix build with CMake 4
    Closes: #1113005
  * d/watch: version=5
  * Cleanup behind testing + fix clean target
    Closes: #1046269
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)
  * Prevent building on i386 in Salsa CI and tolerate blhc failure

 -- Andreas Tille <tille@debian.org>  Fri, 17 Oct 2025 20:49:50 +0200

iitii (0.0+git20191030.85209e0-3) unstable; urgency=medium

  * Packaging update
  * Standards-Version: 4.7.0 (routine-update)
  * Replace transitional package pkg-config by pkgconf in Build-Depends
    (routine-update)
  * d/copyright: Review thanks to lrc

 -- Andreas Tille <tille@debian.org>  Sat, 14 Dec 2024 18:52:28 +0100

iitii (0.0+git20191030.85209e0-2) unstable; urgency=medium

  * Rules-Requires-Root: no (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 18 Oct 2020 21:01:11 +0200

iitii (0.0+git20191030.85209e0-1) unstable; urgency=medium

  * Initial release (Closes: #962557)

 -- Andreas Tille <tille@debian.org>  Tue, 09 Jun 2020 23:14:23 +0200
