=== debian/control ===
Source: iitii
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Andreas Tille <tille@debian.org>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libips4o-dev,
 libargs-dev,
 libmmap-allocator-dev,
 libopenmpi-dev,
 catch2 <!nocheck>,
 pkgconf <!nocheck>,
 libhts-dev <!nocheck>,
 libglib2.0-dev <!nocheck>,
Vcs-Browser: https://salsa.debian.org/med-team/iitii
Vcs-Git: https://salsa.debian.org/med-team/iitii.git
Homepage: https://github.com/ekg/iitii
Rules-Requires-Root: no

Package: iitii
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Implicit Interval Tree with Interpolation Index
 Iitii is a data structure for indexing begin/end position intervals,
 such as genomic feature annotations, and answering requests for all
 items overlapping a query interval. Building on cgranges by Heng Li,
 iitii explores ideas from DBMS interpolation search and learned index
 structures to speed up queries on large datasets.

Package: libiitii-dev
Architecture: all
Section: libdevel
Depends:
 ${misc:Depends},
 libips4o-dev,
 libargs-dev,
 libmmap-allocator-dev,
Description: Implicit Interval Tree with Interpolation Index (devel)
 Iitii is a data structure for indexing begin/end position intervals,
 such as genomic feature annotations, and answering requests for all
 items overlapping a query interval. Building on cgranges by Heng Li,
 iitii explores ideas from DBMS interpolation search and learned index
 structures to speed up queries on large datasets.
 .
 This package contains the header files for development.
